
// Example wait for Interupt INT0,INT1 for sending packet
// Every defined time send Battery status,Temperature 
// Use ACK from Gateway..
// If no ACK then generate Beep tone fom chime..

#include <MySensor.h>
#include <SPI.h>
#include <avr/pgmspace.h>
//#include <Debounce.h>
#include <Bounce2.h>

// Table for Temperature read .. value are from -40 to 215 Celsia..
const unsigned char  Temp_table[] PROGMEM=
{
0xFF,0xE6,0xD2,0xC5,0xBB,0xB4,0xAD,0xA8,0xA3,0x9F,0x9B,0x98,0x95,0x92,0x90,0x8E,
0x8B,0x89,0x87,0x86,0x84,0x82,0x81,0x7F,0x7E,0x7C,0x7B,0x7A,0x78,0x77,0x76,0x75,
0x74,0x73,0x72,0x71,0x70,0x6F,0x6E,0x6D,0x6D,0x6C,0x6B,0x6A,0x69,0x69,0x68,0x67,
0x66,0x66,0x65,0x64,0x64,0x63,0x62,0x62,0x61,0x61,0x60,0x5F,0x5F,0x5E,0x5E,0x5D,
0x5D,0x5C,0x5B,0x5B,0x5A,0x5A,0x59,0x59,0x58,0x58,0x57,0x57,0x56,0x56,0x55,0x55,
0x55,0x54,0x54,0x53,0x53,0x52,0x52,0x51,0x51,0x51,0x50,0x50,0x4F,0x4F,0x4E,0x4E,
0x4E,0x4D,0x4D,0x4C,0x4C,0x4C,0x4B,0x4B,0x4B,0x4A,0x4A,0x49,0x49,0x49,0x48,0x48,
0x47,0x47,0x47,0x46,0x46,0x46,0x45,0x45,0x45,0x44,0x44,0x43,0x43,0x43,0x42,0x42,
0x42,0x41,0x41,0x41,0x40,0x40,0x40,0x3F,0x3F,0x3E,0x3E,0x3E,0x3D,0x3D,0x3D,0x3C,
0x3C,0x3C,0x3B,0x3B,0x3B,0x3A,0x3A,0x3A,0x39,0x39,0x38,0x38,0x38,0x37,0x37,0x37,
0x36,0x36,0x36,0x35,0x35,0x35,0x34,0x34,0x33,0x33,0x33,0x32,0x32,0x32,0x31,0x31,
0x31,0x30,0x30,0x2F,0x2F,0x2F,0x2E,0x2E,0x2D,0x2D,0x2D,0x2C,0x2C,0x2B,0x2B,0x2B,
0x2A,0x2A,0x29,0x29,0x28,0x28,0x28,0x27,0x27,0x26,0x26,0x25,0x25,0x24,0x24,0x23,
0x23,0x22,0x22,0x21,0x21,0x20,0x20,0x1F,0x1F,0x1E,0x1E,0x1D,0x1C,0x1C,0x1B,0x1B,
0x1A,0x19,0x19,0x18,0x17,0x16,0x16,0x15,0x14,0x13,0x12,0x12,0x11,0x10,0x0F,0x0E,
0x0C,0x0B,0x0A,0x09,0x07,0x06,0x04,0x02,0x00,0x00,0x00,0x00,0x00,0x00,0x00,0x00
};


const uint8_t BATTERY_SENSE_PIN = A0;  // select the input pin for the battery sense point
#define	iVbat	39
const uint8_t Temp_Sense_Pin  = A1;    // Temperature sensor on A1 input pin..
#define  Temp_Enable_Pin  7              // If want read temperature then need power UP sensor..

#define SKETCH_NAME "Bin.Sensor Sleep"
#define SKETCH_MAJOR_VER "1"
#define SKETCH_MINOR_VER "0"

#define PRIMARY_CHILD_ID 3
#define SECONDARY_CHILD_ID 4
#define THIRD_CHILD_ID 5


#define Led_Green     4
#define Led_Green_On  1
#define Led_Green_Off 0

#define CHIME_PIN  6
#define CHIME_ON   1
#define CHIME_OFF  0

#define Sleep_Time  60000

#define PRIMARY_BUTTON_PIN 2   // Arduino Digital I/O pin for button/reed switch
#define SECONDARY_BUTTON_PIN 3 // Arduino Digital I/O pin for button/reed switch

#if (PRIMARY_BUTTON_PIN < 2 || PRIMARY_BUTTON_PIN > 3)
#error PRIMARY_BUTTON_PIN must be either 2 or 3 for interrupts to work
#endif
#if (SECONDARY_BUTTON_PIN < 2 || SECONDARY_BUTTON_PIN > 3)
#error SECONDARY_BUTTON_PIN must be either 2 or 3 for interrupts to work
#endif
#if (PRIMARY_BUTTON_PIN == SECONDARY_BUTTON_PIN)
#error PRIMARY_BUTTON_PIN and BUTTON_PIN2 cannot be the same
#endif
#if (PRIMARY_CHILD_ID == SECONDARY_CHILD_ID)
#error PRIMARY_CHILD_ID and SECONDARY_CHILD_ID cannot be the same
#endif
 
MySensor sensor_node;
uint8_t iACK;
unsigned long saved_time;

// Change to V_LIGHT if you use S_LIGHT in presentation below
MyMessage msg(PRIMARY_CHILD_ID, V_TRIPPED);
MyMessage msg2(SECONDARY_CHILD_ID, V_TRIPPED);
MyMessage msg3(THIRD_CHILD_ID, V_TEMP);

Bounce debouncer1 = Bounce();
Bounce debouncer2 = Bounce();

void setup()  
{  

  iACK=0;

  sensor_node.begin(incomingMessage,AUTO); //NULL incomingMessage

  // Setup the buttons
  pinMode(PRIMARY_BUTTON_PIN, INPUT);
  pinMode(SECONDARY_BUTTON_PIN, INPUT);

  // Activate internal pull-ups
  digitalWrite(PRIMARY_BUTTON_PIN, HIGH);
  digitalWrite(SECONDARY_BUTTON_PIN, HIGH);
  
  // Send the sketch version information to the gateway and Controller
  sensor_node.sendSketchInfo(SKETCH_NAME, SKETCH_MAJOR_VER"."SKETCH_MINOR_VER);

  // Register binary input sensor to sensor_node (they will be created as child devices)
  // You can use S_DOOR, S_MOTION or S_LIGHT here depending on your usage. 
  // If S_LIGHT is used, remember to update variable type you send in. See "msg" above.
  sensor_node.present(PRIMARY_CHILD_ID, S_DOOR);  
  sensor_node.present(SECONDARY_CHILD_ID, S_DOOR);  
  sensor_node.present(THIRD_CHILD_ID, S_TEMP);  
  // disable UART

#ifndef  DEBUG
  Serial.end();
  pinMode(1, OUTPUT);
  digitalWrite(1, LOW);
#endif

  saved_time = millis();
  debouncer1.attach(PRIMARY_BUTTON_PIN);
  debouncer2.attach(SECONDARY_BUTTON_PIN);
  debouncer1.interval(20);
  debouncer2.interval(20);
  
}

// Wait for incoming message
void incomingMessage(const MyMessage &message) 
{
if (message.isAck()) iACK=1;  // ACK received..
}

// Led blink function - if INT0 or INT1
void LedBlink()
{
  pinMode(Led_Green, OUTPUT);
  digitalWrite(Led_Green, HIGH);

  delay(10);

  pinMode(Led_Green, INPUT);
  digitalWrite(Led_Green, LOW);
  
}

// Loop will iterate on changes on the BUTTON_PINs
void loop() 
{
  uint8_t value;
  static uint8_t iCount=0;
  static int8_t iSleepRet=-1;
  static uint8_t sentValue=2;
  static uint8_t sentValue2=2;

  sensor_node.process();


  debouncer1.update ();
  debouncer2.update ();
// Short delay to allow buttons to properly settle

  value = debouncer1.read();
  if (value != sentValue) 
     {
     // Value has changed from last transmission, send the updated value
     LedBlink();
     sensor_node.send(msg.set(value==HIGH ? 1 : 0),true);
     sentValue = value;
     saved_time = millis();
     }
  
  value = debouncer2.read();
  if (value != sentValue2) 
     {
     // Value has changed from last transmission, send the updated value
     LedBlink();
     sensor_node.send(msg2.set(value==HIGH ? 1 : 0),true);
     sentValue2 = value;
     saved_time = millis();
     }
  
  if (iSleepRet==-1)
    {
     iSleepRet=-2; 
     iCount++;
      if (iCount=1)
      {
       // use the 1.1 V internal reference
       analogReference(INTERNAL);
       delay(5);
       // get the battery Voltage uVbat = (ReadAdc(iVbatMux)*iVbat)/1023;
       uint8_t BatValue = (analogRead(BATTERY_SENSE_PIN)*iVbat)/1023; // in Voltage * 10
       sensor_node.sendBatteryLevel(BatValue,true);
       saved_time = millis();
      }
      if (iCount=2)
      {
      iCount=0;
       // use the Default Reference input .. connected to AVCC
      analogReference(DEFAULT);
      pinMode(Temp_Enable_Pin, OUTPUT);
      digitalWrite(Temp_Enable_Pin, HIGH);
      delay(5);
      int8_t uTemp = (pgm_read_byte(&Temp_table[analogRead(Temp_Sense_Pin)/4]))-40;
      pinMode(Temp_Enable_Pin, INPUT);
      digitalWrite(Temp_Enable_Pin, LOW);
      sensor_node.send(msg3.set(uTemp),true);
      saved_time = millis();
      }
    }

 if ((millis() - saved_time) > 100)
    {
        //lastrun = millis();
        // Sleep until something happens with the sensor
      if ((iACK==0)) //&&(iSleepRet>-1)
        {
        pinMode(CHIME_PIN, OUTPUT);
        digitalWrite(CHIME_PIN, HIGH);
        delay(50);
        digitalWrite(CHIME_PIN, LOW);
        pinMode(CHIME_PIN, INPUT);
        }
       else iACK=0;

        saved_time = millis();
        iSleepRet = sensor_node.sleep(PRIMARY_BUTTON_PIN-2, CHANGE, SECONDARY_BUTTON_PIN-2, CHANGE, Sleep_Time);
      // (RISING, FALLING, CHANGE) 
        
    }

} 



